<script setup lang="ts">
import { ref } from 'vue'

const inputValue = ref('')

const fixBtn = {
  add: false,
  edit: true,
  delete: true
}

const tableHeaders = reactive([
  { title: '客戶代號' },
  { title: '客戶簡稱' },
  { title: '客戶系統別' },
  { title: '健保特約類別' },
  { title: '客戶類別' },
  { title: 'Inactive' }
])

const tableData = reactive([
  {
    clientID: 'A10201',
    clientAbbreviation: '臺北榮民總醫院',
    clientSystemCategory: '北榮系統',
    healthInsuranceCategory: '退輔會系統',
    clientCategory: 'MC1',
    isInactive: false
  },
  {
    clientID: 'A10201',
    clientAbbreviation: '臺北榮民總醫院',
    clientSystemCategory: '北榮系統',
    healthInsuranceCategory: '退輔會系統',
    clientCategory: 'MC1',
    isInactive: false
  },
  {
    clientID: 'A10201',
    clientAbbreviation: '臺北榮民總醫院',
    clientSystemCategory: '北榮系統',
    healthInsuranceCategory: '退輔會系統',
    clientCategory: 'MC1',
    isInactive: false
  }
])

const pageObj = reactive({
  pageItems: 10, // 一頁秀幾筆
  currentPage: 1, // 當前頁數
  pageSize: 5 // 分頁中間數字最多顯示的數目
})

// 總頁數
const totalPage = computed(() => {
  return Math.ceil(tableData.length / pageObj.pageItems)
})

const nowPage = computed(() => {
  const min = (pageObj.currentPage - 1) * pageObj.pageItems
  const max = min + pageObj.pageItems - 1
  return { min, max }
})

// 篩出來渲染的資料
const showData = computed(() => {
  return tableData.filter((item, index) => {
    return index >= nowPage.value.min && index < nowPage.value.max + 1
  })
})

const onEdit = (val: any) => {
  console.log('parent edit', val)
}

const onDelete = (val: any) => {
  console.log('parent delete', val)
}

const turnPage = (val: any) => {
  pageObj.currentPage = val
}
</script>

<template>
  <main class="container-fluid">
    <header>
      <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="font-zh-small-regular breadcrumb-item">
            <a href="#">客戶維護</a>
          </li>
          <li
            aria-current="page"
            class="font-zh-small-regular breadcrumb-item active"
          >
            客戶架構
          </li>
        </ol>
      </nav>
      <div class="d-flex justify-content-end w-100">
        <img
          alt="header-illustration"
          class="header-illustration"
          src="@/assets/images/header-illustration.svg"
        />
      </div>
      <div class="function-group">
        <div class="display-info">
          <h3 class="font-zh-h3">客戶查詢</h3>
          <div class="interact-button-list d-flex">
            <button
              class="btn btn-middle-gray-200 font-zh-button d-flex justify-content-center align-items-center"
              type="button"
            >
              <p>新增</p>
              <div class="icon-create"></div>
            </button>
          </div>
        </div>
      </div>
      <div class="single-operation-board card">
        <h3 class="font-zh-h3 text-color-main">查詢條件</h3>
        <form>
          <div class="card-body">
            <div class="input-item-list row">
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userAccount"
                    >客戶類別</label
                  >
                  <common-select
                    v-model="selectValue"
                    :select-list-data="selectList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userPassword"
                    >客戶系統別</label
                  >
                  <common-select
                    v-model="selectValue"
                    :select-list-data="selectList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userPassword"
                    >健保特約類別</label
                  >
                  <common-select
                    v-model="selectValue"
                    :select-list-data="selectList"
                  />
                </div>
              </div>
              <div class="col-3">
                <div class="input-item">
                  <label class="font-zh-p-medium form-label" for="userPassword"
                    >客戶簡稱</label
                  >
                  <common-input v-model="inputValue" />
                </div>
              </div>
            </div>
            <div class="row align-items-end">
              <div class="col-3">
                <div class="form-check-group">
                  <p class="font-en-p-medium">Active / Inactive</p>
                  <div class="form-check-list d-flex justify-content-between">
                    <div class="form-check">
                      <input
                        id="flexRadioDefault1"
                        class="form-check-input"
                        name="flexRadioDefault"
                        type="radio"
                      />
                      <label
                        class="font-en-p-medium form-check-label"
                        for="flexRadioDefault1"
                      >
                        Active
                      </label>
                    </div>
                    <div class="form-check">
                      <input
                        id="flexRadioDefault2"
                        class="form-check-input"
                        name="flexRadioDefault"
                        type="radio"
                      />
                      <label
                        class="font-en-p-medium form-check-label"
                        for="flexRadioDefault2"
                      >
                        Inactive
                      </label>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-3">
                <div class="d-grid gap-2">
                  <button
                    class="btn btn-large-secondary font-zh-button d-flex justify-content-center align-items-center"
                    type="submit"
                  >
                    <p>查詢</p>
                    <div class="icon-search"></div>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </form>
      </div>
    </header>
    <div>
      <basic-table
        :fix-btn="fixBtn"
        :table-data="showData"
        :table-headers="tableHeaders"
        @delete="onDelete"
        @edit="onEdit"
      />
      <table-pagination
        :page-obj="pageObj"
        :total-page="totalPage"
        @turn-page="turnPage"
      />
    </div>
  </main>
</template>

<style lang="scss" scoped>
/** style */
</style>
